/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	Copyright 1998-2002 Anton Vinokurov <anton@netams.com>
***	Copyright 2002-2008 NeTAMS Development Team
***	This code is GPL v3
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: attrlist.h,v 1.34 2008-02-23 08:35:02 anton Exp $ */

//attr_type should be orderer to improve perfomance
//then less - then more important
enum attr_type { ATTR_NONE=0, ATTR_IPV4=1, ATTR_MAC=2, ATTR_EMAIL=3 };

class Attribute {
	public:
		attr_type type;
		
		Attribute(attr_type);
		virtual ~Attribute() {};
		
		virtual char* getAttr(char *buf) {return NULL;};
		virtual int setAttr(char **param, char *errbuf=NULL) {return 0;}; //return number of arguments processed
		virtual match Check(Flow *) {return MATCH_NONE;};
		
		const char* name();
};
/////////////////////////////////////////////////////////////////////////////////////
Attribute* getAttr(Attribute **attrlist, attr_type atype);
char* getAttr(Attribute **attrlist, attr_type atype, char *buf);
int setAttr(Attribute **attrlist, struct cli_def *cli, char **param);
/////////////////////////////////////////////////////////////////////////////////////
